Index: examples/python_tests/access_rt2/access.save
===================================================================
--- examples/python_tests/access_rt2/access.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/access_rt2/access.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/acme_friend_rt1/friend.save
===================================================================
--- examples/python_tests/acme_friend_rt1/friend.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/acme_friend_rt1/friend.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/acme_rockets_intersection_rt0/intersect.save
===================================================================
--- examples/python_tests/acme_rockets_intersection_rt0/intersect.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/acme_rockets_intersection_rt0/intersect.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/acme_rockets_rt0/rocket.save
===================================================================
--- examples/python_tests/acme_rockets_rt0/rocket.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/acme_rockets_rt0/rocket.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/alice_rt1/alice.save
===================================================================
--- examples/python_tests/alice_rt1/alice.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/alice_rt1/alice.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/alumni2_rt1/alumni2.save
===================================================================
--- examples/python_tests/alumni2_rt1/alumni2.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/alumni2_rt1/alumni2.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/alumni3_rt1/alumni3.save
===================================================================
--- examples/python_tests/alumni3_rt1/alumni3.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/alumni3_rt1/alumni3.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/alumni_rt1/alumni.save
===================================================================
--- examples/python_tests/alumni_rt1/alumni.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/alumni_rt1/alumni.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/balltime_rt2/ball.save
===================================================================
--- examples/python_tests/balltime_rt2/ball.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/balltime_rt2/ball.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/basic_id/id.save
===================================================================
--- examples/python_tests/basic_id/id.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/basic_id/id.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 python: Couldn't load ID/KEY IDKEY cert Tom_IDKEY.pem
 ABAC version 0.2.2
Index: examples/python_tests/evaluator_rt1/evaluator.save
===================================================================
--- examples/python_tests/evaluator_rt1/evaluator.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/evaluator_rt1/evaluator.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/experiment_create_rt0/experiment.save
===================================================================
--- examples/python_tests/experiment_create_rt0/experiment.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/experiment_create_rt0/experiment.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/file_read_rt2/file.save
===================================================================
--- examples/python_tests/file_read_rt2/file.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/file_read_rt2/file.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/fruits_rt2/fruit.save
===================================================================
--- examples/python_tests/fruits_rt2/fruit.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/fruits_rt2/fruit.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/leader_rt1/leader.save
===================================================================
--- examples/python_tests/leader_rt1/leader.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/leader_rt1/leader.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/payraise_rt1/pay.save
===================================================================
--- examples/python_tests/payraise_rt1/pay.save	(revision 2b4e740d65ffe3ec9cd86b464ab1c4978b6b51f9)
+++ examples/python_tests/payraise_rt1/pay.save	(revision 68109e3f58ef220751570962b6cabc67347f1a66)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...