Index: java/build.xml
===================================================================
--- java/build.xml	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/build.xml	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -31,5 +31,5 @@
   <property name="regression.class" value="Regression"/>
   <property name="example.class" value="CreateExample"/>
-  <property name="version" value="1.4"/>
+  <property name="version" value="1.5"/>
 
   <path id="compile.classpath">
Index: java/net/deterlab/abac/ABACException.java
===================================================================
--- java/net/deterlab/abac/ABACException.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/ABACException.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -7,5 +7,5 @@
  * possible.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class ABACException extends Exception  {
Index: java/net/deterlab/abac/BadSignatureException.java
===================================================================
--- java/net/deterlab/abac/BadSignatureException.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/BadSignatureException.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -5,5 +5,5 @@
  * include a cause from the underlying library that caused them when possible.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class BadSignatureException extends ABACException  {
Index: java/net/deterlab/abac/CertInvalidException.java
===================================================================
--- java/net/deterlab/abac/CertInvalidException.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/CertInvalidException.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -7,5 +7,5 @@
  * library that caused them when possible.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class CertInvalidException extends ABACException  {
Index: java/net/deterlab/abac/Context.java
===================================================================
--- java/net/deterlab/abac/Context.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/Context.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -22,5 +22,5 @@
  * proof.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class Context {
@@ -80,5 +80,5 @@
      * or total proof, and success indicates whether the proof succeeded.
      * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
-     * @version 1.4
+     * @version 1.5
      */
     public class QueryResult {
Index: java/net/deterlab/abac/Credential.java
===================================================================
--- java/net/deterlab/abac/Credential.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/Credential.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -21,5 +21,5 @@
  * their constituent Roles.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public abstract class Credential implements Comparable {
Index: java/net/deterlab/abac/CredentialFactory.java
===================================================================
--- java/net/deterlab/abac/CredentialFactory.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/CredentialFactory.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -11,5 +11,5 @@
  * CredentialFactory.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class CredentialFactory implements Cloneable {
Index: java/net/deterlab/abac/CredentialFactorySpecialization.java
===================================================================
--- java/net/deterlab/abac/CredentialFactorySpecialization.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/CredentialFactorySpecialization.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -11,5 +11,5 @@
  * will be a wrapper around a constructor.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public abstract class CredentialFactorySpecialization {
Index: java/net/deterlab/abac/GENICredential.java
===================================================================
--- java/net/deterlab/abac/GENICredential.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/GENICredential.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -27,5 +27,5 @@
  * Abstract Base class from which GENI credentials are derived.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public abstract class GENICredential extends Credential implements Comparable {
Index: java/net/deterlab/abac/GENICredentialv1_0.java
===================================================================
--- java/net/deterlab/abac/GENICredentialv1_0.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/GENICredentialv1_0.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -28,5 +28,5 @@
  * 1.0 GENI credential.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class GENICredentialv1_0 extends GENICredential implements Comparable {
Index: java/net/deterlab/abac/GENICredentialv1_1.java
===================================================================
--- java/net/deterlab/abac/GENICredentialv1_1.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/GENICredentialv1_1.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -27,5 +27,5 @@
  * An ABAC credential formatted as an abac-type GENI credential, version 1.1.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class GENICredentialv1_1 extends GENICredential 
Index: java/net/deterlab/abac/GENIPrivCredential.java
===================================================================
--- java/net/deterlab/abac/GENIPrivCredential.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/GENIPrivCredential.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -34,5 +34,5 @@
  * An ABAC credential formatted as an abac-type GENI credential.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class GENIPrivCredential extends GENICredential {
Index: java/net/deterlab/abac/Identity.java
===================================================================
--- java/net/deterlab/abac/Identity.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/Identity.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -22,5 +22,5 @@
  * something of a jabac extension.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class Identity implements Comparable {
Index: java/net/deterlab/abac/InternalCredential.java
===================================================================
--- java/net/deterlab/abac/InternalCredential.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/InternalCredential.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -21,5 +21,5 @@
  * placeholder credentials outside the main jabac library.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class InternalCredential extends Credential {
Index: java/net/deterlab/abac/KeyIDMap.java
===================================================================
--- java/net/deterlab/abac/KeyIDMap.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/KeyIDMap.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -22,5 +22,5 @@
  * proof.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class KeyIDMap {
Index: java/net/deterlab/abac/MapsKeyIDs.java
===================================================================
--- java/net/deterlab/abac/MapsKeyIDs.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/MapsKeyIDs.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -4,5 +4,5 @@
  * If this class constructs a key mapping, this interface gives access to it.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public interface MapsKeyIDs {
Index: java/net/deterlab/abac/MissingIssuerException.java
===================================================================
--- java/net/deterlab/abac/MissingIssuerException.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/MissingIssuerException.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -6,5 +6,5 @@
  * them when possible.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class MissingIssuerException extends ABACException  {
Index: java/net/deterlab/abac/Query.java
===================================================================
--- java/net/deterlab/abac/Query.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/Query.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -12,5 +12,5 @@
  * well as reachability in either direction. See the run method for details.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 class Query {
Index: java/net/deterlab/abac/Role.java
===================================================================
--- java/net/deterlab/abac/Role.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/Role.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -6,5 +6,5 @@
  * Represents a role, which is a vertex in a Credential graph.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class Role implements Comparable {
Index: java/net/deterlab/abac/X509Credential.java
===================================================================
--- java/net/deterlab/abac/X509Credential.java	(revision 28d6d08c1a4b46545f54d859376ce89129587aa5)
+++ java/net/deterlab/abac/X509Credential.java	(revision 84038c8f9927bb30f350fbcb1c1144e0fc9b921a)
@@ -21,5 +21,5 @@
  * their constituent Roles.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.4
+ * @version 1.5
  */
 public class X509Credential extends Credential implements Comparable {