Index: examples/creddy_prover_tests/README
===================================================================
--- examples/creddy_prover_tests/README	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/creddy_prover_tests/README	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -28,4 +28,7 @@
         --dump <file> 
     extracts all credentials from the prolog db
+        --dbdump
+    extracts all prolog rules directly from the prolog db
+
 
 keystore is the location where the prover will search to load credentials.
Index: examples/creddy_prover_tests/allout.save
===================================================================
--- examples/creddy_prover_tests/allout.save	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/creddy_prover_tests/allout.save	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -112,5 +112,5 @@
 prover success!!
 credentials needed :
- pStateU.foundingAlumni  <- pStateU.diploma(_,Year:[1963,1961,1960]) 
+ pStateU.foundingAlumni  <- pStateU.diploma(_,Year:[1960,1961,1963]) 
  pStateU.diploma('mathmatics',1961)  <- pBob 
  
@@ -129,5 +129,5 @@
 prover success!!
 credentials needed :
- pStateU.foundingAlumni  <- pStateU.diploma(D:['psychology','mathmatics'],Year:[1963,1961,1960]) 
+ pStateU.foundingAlumni  <- pStateU.diploma(D:['mathmatics','psychology'],Year:[1960,1961,1963]) 
  pStateU.diploma('mathmatics',1961)  <- pBob 
  
@@ -148,5 +148,5 @@
 prover success!!
 credentials needed :
- pStateU.foundingAlumni  <- pStateU.diploma(D:['psychology','mathmatics'],Year:[1963,1961,1960]) 
+ pStateU.foundingAlumni  <- pStateU.diploma(D:['mathmatics','psychology'],Year:[1960,1961,1963]) 
  pStateU.diploma('psychology',1960)  <- pJan 
 
@@ -161,5 +161,5 @@
 prover success!!
 credentials needed :
- pStateU.foundingAlumni  <- pStateU.diploma(_,Year:[1955 .. 1958]) 
+ pStateU.foundingAlumni  <- pStateU.diploma(_,Year:[1955..1958]) 
  pStateU.diploma('psychology',1956)  <- pMaryann 
  
@@ -168,5 +168,5 @@
 prover success!!
 credentials needed :
- pStateU.foundingAlumni  <- pStateU.diploma(_,Year:[1955 .. 1958]) 
+ pStateU.foundingAlumni  <- pStateU.diploma(_,Year:[1955..1958]) 
  pStateU.diploma('zoology',1955)  <- pJoe 
 
@@ -178,5 +178,5 @@
 credentials needed :
  pLeague.stadium('access',true,F:pLeague.gametime(T))  <- pLeague.players(T) 
- pLeague.gametime('north')  <- time(2012,02,28,13,00,00) 
+ pLeague.gametime('north')  <- 20120228T130000 
  pLeague.players('north')  <- pJohn 
  
@@ -189,5 +189,5 @@
 prover success!!
 credentials needed :
- pLeague.stadium('access',B:[true],F:[20120228T080000 .. 20120228T090000])  <- pLeague.players(T) 
+ pLeague.stadium('access',B:[true],F:[20120228T080000..20120228T090000])  <- pLeague.players(T) 
  pLeague.players('south')  <- pMark 
 
@@ -257,5 +257,5 @@
 prover success!!
 credentials needed :
- pMary.what2eat  <- pRalphs.fruitprice(P:[.. 2.00]) 
+ pMary.what2eat  <- pRalphs.fruitprice(P:[..2.00]) 
  pRalphs.fruitprice(0.50)  <- 'navel orange' 
  
@@ -264,5 +264,5 @@
 prover success!!
 credentials needed :
- pMary.what2eat  <- pRalphs.fruitprice(P:[.. 2.00]) 
+ pMary.what2eat  <- pRalphs.fruitprice(P:[..2.00]) 
  pRalphs.fruitprice(1.50)  <- 'kiwi' 
  
Index: examples/creddy_prover_tests/experiment_create_rt0/README
===================================================================
--- examples/creddy_prover_tests/experiment_create_rt0/README	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/creddy_prover_tests/experiment_create_rt0/README	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -35,5 +35,5 @@
 creddy --attribute \
        --issuer Acme_ID.pem --key Acme_private.pem --role experiment_create \
-       --subject-cert Acme_ID.pem --subject-role partner.experiment_create \
+       --subject-cert Acme_ID.pem --subject-link partner --subject-role experiment_create \
        --out Acme_experiment_create__Acme_partner_experiment_create_attr.der
 
@@ -47,5 +47,5 @@
 creddy --attribute \
        --issuer Globotron_ID.pem --key Globotron_private.pem --role experiment_create \
-       --subject-cert Globotron_ID.pem --subject-role admin.power_user \
+       --subject-cert Globotron_ID.pem --subject-link admin --subject-role power_user \
        --out Globotron_experiment_create__Globotron_admin_power_user_attr.der
 
Index: examples/creddy_prover_tests/payraise_rt1/README
===================================================================
--- examples/creddy_prover_tests/payraise_rt1/README	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/creddy_prover_tests/payraise_rt1/README	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -38,6 +38,6 @@
 joe_keyid=`creddy --keyid --cert Joe_ID.pem`
 
-performance_qT="evaluatorOf([principal:?this]).goodPerformance"
-niceguy_qT="managerOf([principal:?this]).niceCoworker"
+performance_qT="evaluatorOf([principal:?this])"
+niceguy_qT="managerOf([principal:?this])"
 
 manager_qZ="managerOf([principal:?Z])"
@@ -53,6 +53,8 @@
 creddy --attribute \
        --issuer Alpha_ID.pem --key Alpha_private.pem --role payRaise \
-       --subject-cert Alpha_ID.pem --subject-role "$performance_qT" \
-       --subject-cert Alpha_ID.pem --subject-role "$niceguy_qT" \
+       --subject-cert Alpha_ID.pem --subject-link "$performance_qT" \
+                                     --subject-role goodPerformance \
+       --subject-cert Alpha_ID.pem --subject-link "$niceguy_qT" \
+                                     --subject-role niceCoworker \
        --out Alpha_payraise__Alpha_performance_qT_niceguy_qT_attr.der
 
Index: examples/creddy_prover_tests/payraise_rt1/run_query
===================================================================
--- examples/creddy_prover_tests/payraise_rt1/run_query	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/creddy_prover_tests/payraise_rt1/run_query	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -24,4 +24,5 @@
 ## dump all credentials
 $eloc/abac_prover_yap  --keystore $keyloc --dump creds_dump
+#$eloc/abac_prover_yap  --keystore $keyloc --dbdump
 
 # [keyid:alpha].role:payRaise <-?- [keyid:Joe] (no)
Index: examples/python_tests/alice_rt1/alice.save
===================================================================
--- examples/python_tests/alice_rt1/alice.save	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/python_tests/alice_rt1/alice.save	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -12,5 +12,5 @@
 pParty.about_another_float(8) <- pMarchhare
 pParty.about_another_integer(-7) <- pMarchhare
-pParty.about_another_time(time(2020,11,01,18,29,30)) <- pMarchhare
+pParty.about_another_time(20201101T182930) <- pMarchhare
 pParty.about_boolean(true) <- pMarchhare
 pParty.about_float(-200.0) <- pMarchhare
@@ -18,9 +18,9 @@
 pParty.about_key(pTea) <- pMarchhare
 pParty.about_other_party(pTea,_,99,AAA,BBB,true,_) <- pMarchhare
-pParty.about(pTea,time(2010,10,10,00,00,00),true,4,-200.0,8,time(2012,02,05,18,29,30),'a list','file://usr/party/~teaparty') <- pParty.guestOf(pMarchhare)
+pParty.about(pTea,20101010T000000,true,4,-200.0,8,20120205T182930,'a list','file://usr/party/~teaparty') <- pParty.guestOf(pMarchhare)
 pParty.about_string2('a mangled \'string\'') <- pMarchhare
 pParty.about_string('a confused party') <- pMarchhare
 pParty.about_another_float(0.22) <- pMarchhare
-pParty.about_time(time(2020,11,01,00,00,00)) <- pMarchhare
+pParty.about_time(20201101T000000) <- pMarchhare
 pParty.about_urn('file://user/local/party/~sillyparty') <- pMarchhare
 pParty.friendOf(pAlice) <- pHatter
Index: examples/python_tests/alumni2_rt1/alumni2.save
===================================================================
--- examples/python_tests/alumni2_rt1/alumni2.save	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/python_tests/alumni2_rt1/alumni2.save	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -11,9 +11,9 @@
 pStateU.diploma('psychology',1962) <- pMaryann
 pStateU.diploma('zoology',1955) <- pJoe
-pStateU.foundingAlumni <- pStateU.diploma(_,Year:[1963,1961,1960])
+pStateU.foundingAlumni <- pStateU.diploma(_,Year:[1960,1961,1963])
 
 ===good============ stateU.foundingAlumni <- Bob
 YAP query succeed
-pStateU.foundingAlumni <- pStateU.diploma(_,Year:[1963,1961,1960])
+pStateU.foundingAlumni <- pStateU.diploma(_,Year:[1960,1961,1963])
 pStateU.diploma('mathmatics',1961) <- pBob
 
Index: examples/python_tests/alumni2_rt1/attr.py
===================================================================
--- examples/python_tests/alumni2_rt1/attr.py	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/python_tests/alumni2_rt1/attr.py	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -64,7 +64,7 @@
 
 # add specific target value for the integer range constraint
+cond.constraint_add_integer_target(1963)
+cond.constraint_add_integer_target(1961)
 cond.constraint_add_integer_target(1960)
-cond.constraint_add_integer_target(1961)
-cond.constraint_add_integer_target(1963)
 
 # create a paramter term that has a range constraint on it,
Index: examples/python_tests/alumni_rt1/alumni.save
===================================================================
--- examples/python_tests/alumni_rt1/alumni.save	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/python_tests/alumni_rt1/alumni.save	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -1,4 +1,4 @@
 % Restoring file /usr/local/lib/Yap/startup.yss
-  
+
 ...final principal set...
 (pBob,keyid,y) 
@@ -11,5 +11,5 @@
 pStateU.diploma('psychology',1956) <- pMaryann
 pStateU.diploma('zoology',1955) <- pJoe
-pStateU.foundingAlumni <- pStateU.diploma(_,Year:[1955 .. 1958])
+pStateU.foundingAlumni <- pStateU.diploma(_,Year:[1955..1958])
 
 ===bad============ stateU.foundingAlumni <- Bob
@@ -18,9 +18,9 @@
 ===good============ stateU.foundingAlumni <- Maryann
 YAP query succeed
-pStateU.foundingAlumni <- pStateU.diploma(_,Year:[1955 .. 1958])
+pStateU.foundingAlumni <- pStateU.diploma(_,Year:[1955..1958])
 pStateU.diploma('psychology',1956) <- pMaryann
 
 ===good============ stateU.foundingAlumni <- Joe
 YAP query succeed
-pStateU.foundingAlumni <- pStateU.diploma(_,Year:[1955 .. 1958])
+pStateU.foundingAlumni <- pStateU.diploma(_,Year:[1955..1958])
 pStateU.diploma('zoology',1955) <- pJoe
Index: examples/python_tests/balltime_rt2/ball.save
===================================================================
--- examples/python_tests/balltime_rt2/ball.save	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/python_tests/balltime_rt2/ball.save	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -1,4 +1,4 @@
 % Restoring file /usr/local/lib/Yap/startup.yss
-  
+
 ...final principal set...
 (pJohn,keyid,y) 
@@ -8,7 +8,7 @@
 ...final policy attribute set...
 pLeague.stadium('access',true,F:pLeague.gametime(T)) <- pLeague.players(T)
-pLeague.stadium('access',B:[true],F:[20120228T080000 .. 20120228T090000]) <- pLeague.players(T)
-pLeague.gametime('north') <- time(2012,02,28,13,00,00)
-pLeague.gametime('south') <- time(2012,02,28,14,00,00)
+pLeague.stadium('access',B:[true],F:[20120228T080000..20120228T090000]) <- pLeague.players(T)
+pLeague.gametime('north') <- 20120228T130000
+pLeague.gametime('south') <- 20120228T140000
 pLeague.players('north') <- pJohn
 pLeague.players('south') <- pMark
@@ -17,5 +17,5 @@
 YAP query succeed
 pLeague.stadium('access',true,F:pLeague.gametime(T)) <- pLeague.players(T)
-pLeague.gametime('north') <- time(2012,02,28,13,00,00)
+pLeague.gametime('north') <- 20120228T130000
 pLeague.players('north') <- pJohn
 
@@ -25,4 +25,4 @@
 ===good============ league.stadium(access,true,20120128T080000)<-?-mark
 YAP query succeed
-pLeague.stadium('access',B:[true],F:[20120228T080000 .. 20120228T090000]) <- pLeague.players(T)
+pLeague.stadium('access',B:[true],F:[20120228T080000..20120228T090000]) <- pLeague.players(T)
 pLeague.players('south') <- pMark
Index: examples/python_tests/basic_id/id.save
===================================================================
--- examples/python_tests/basic_id/id.save	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/python_tests/basic_id/id.save	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -1,5 +1,5 @@
 % Restoring file /usr/local/lib/Yap/startup.yss
 python: Couldn't load ID/KEY IDKEY cert Tom_IDKEY.pem
-ABAC version 1.0
+ABAC version 2.1.0
 ...initial principal set...
 (pBob,keyid,y) 
Index: examples/python_tests/fruits_rt2/fruit.save
===================================================================
--- examples/python_tests/fruits_rt2/fruit.save	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/python_tests/fruits_rt2/fruit.save	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -1,4 +1,4 @@
 % Restoring file /usr/local/lib/Yap/startup.yss
-   
+
 ...final principal set...
 (pBob,keyid,y) 
@@ -11,15 +11,15 @@
 pRalphs.fruitprice(1.50) <- 'kiwi'
 pRalphs.fruitprice(0.50) <- 'navel orange'
-pBob.what2eat <- pRalphs.fruitprice(P:[1.000000 .. 5.000000])
-pMary.what2eat <- pRalphs.fruitprice(P:[.. 2.000000])
+pBob.what2eat <- pRalphs.fruitprice(P:[1.000000..5.000000])
+pMary.what2eat <- pRalphs.fruitprice(P:[..2.000000])
 
 ===good============ mary.what2eat <- navel orange
 YAP query succeed
-pMary.what2eat <- pRalphs.fruitprice(P:[.. 2.000000])
+pMary.what2eat <- pRalphs.fruitprice(P:[..2.000000])
 pRalphs.fruitprice(0.50) <- 'navel orange'
 
 ===good============ mary.what2eat <- kiwi
 YAP query succeed
-pMary.what2eat <- pRalphs.fruitprice(P:[.. 2.000000])
+pMary.what2eat <- pRalphs.fruitprice(P:[..2.000000])
 pRalphs.fruitprice(1.50) <- 'kiwi'
 
Index: examples/python_tests/payraise_rt1/pay.save
===================================================================
--- examples/python_tests/payraise_rt1/pay.save	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/python_tests/payraise_rt1/pay.save	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -22,5 +22,5 @@
 YAP query succeed
 pAlpha.payRaise <- pAlpha.evaluatorOf(This).goodPerformance & pAlpha.managerOf(This).niceCoworker
-pAlpha.evaluatorOf(pJoe) <- pBob
+pAlpha.evaluatorOf(pMaryann) <- pBob
 pBob.goodPerformance <- pMaryann
 pAlpha.managerOf(Z) <- pAlpha.evaluatorOf(Z)
Index: examples/python_tests/payraise_rt1/query.py
===================================================================
--- examples/python_tests/payraise_rt1/query.py	(revision e3462b4a59b42b4848b5ad88a611880e3200b047)
+++ examples/python_tests/payraise_rt1/query.py	(revision 549656e28a22f7ee432c5e808a001b46b98f7b5b)
@@ -76,2 +76,6 @@
     print "%s <- %s" % (c.head_string(), c.tail_string())
 
+
+##########################################################################
+#ctxt.dump_yap_db()
+