Index: examples/acme_rockets_intersection/Acme_ID.pem
===================================================================
--- examples/acme_rockets_intersection/Acme_ID.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
+++ examples/acme_rockets_intersection/Acme_ID.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
@@ -0,0 +1,19 @@
+-----BEGIN CERTIFICATE-----
+MIIDBDCCAeygAwIBAgIJALWq1UVLzJZ4MA0GCSqGSIb3DQEBBQUAMA8xDTALBgNV
+BAMTBEFjbWUwHhcNMTAwOTE3MjAzNjI4WhcNMTMwOTAxMjAzNjI4WjAPMQ0wCwYD
+VQQDEwRBY21lMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA+LqEHGFo
+AhgLZqYm3vfKMxMZ1KQbWM8lFqv+jp1zF15r4MBxPJ8KwzW5bK/D1+VpWGcdrM4l
+8JTHoPBJdYBqrDkPYdBEUEU4+yc7gQOupdrXVDOaeOS3+SUkT0Zh9gCuWC6KE8yR
+ddR4uj8qb+qYDX8Wo8CoOVvBza8BxGMpSbBeHU+gBTOquMnOZ647yoaHruFn3QkS
+ysrIH3sCAZ3sQWK64iaZwlauQJ9jjT/fi+78tmXR8CYhffbwmbZ6Ds2fNQl77ZQl
+Pk1XG8jKN/KCs72E6wmOXUbk+m6Oqa6H8ZF4F7w819jCsg5uSpTsagyaRbabISGt
+RonxaKR3MiS1bQIDAQABo2MwYTAPBgNVHRMBAf8EBTADAQH/MA4GA1UdDwEB/wQE
+AwIBBjAdBgNVHQ4EFgQUIewSm++fyGoa8gm+erAP+cbYtXMwHwYDVR0jBBgwFoAU
+IewSm++fyGoa8gm+erAP+cbYtXMwDQYJKoZIhvcNAQEFBQADggEBAM7G2FbjocdJ
+Hq/fT8dwgnrDh1zUSUOAcTSs/OBQ+7hj2p+X7Fs9whTyMqPlkbIthqbebGY72QtD
+wRC7Y07rnwONQ+VkG/7/Uxpyxlzf3M27v+cn1e9QXBote193c3i03TeJcKkr6TMP
+3x6nJbB5wPKuWao3hjoKUzRcmCfpwcVnOUbNlPINecZGcidRsYCzLS6h/Ro59KWU
+D70fygIVYR9zKCNg4u9xIYc7sDE6TzBwD++vjhlmlVDuLU+hYqRY879VyMfIinVn
+dmf1DV94HR7TfJyNnvvhmOFeBgWRyQU4LrTR3YrRDyyyy8b4KmnX8vBtYGLTnEEP
+cfXpsyZZxXs=
+-----END CERTIFICATE-----
Index: examples/acme_rockets_intersection/Acme_private.pem
===================================================================
--- examples/acme_rockets_intersection/Acme_private.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
+++ examples/acme_rockets_intersection/Acme_private.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
@@ -0,0 +1,27 @@
+-----BEGIN RSA PRIVATE KEY-----
+MIIEogIAAoIBAQD4uoQcYWgCGAtmpibe98ozExnUpBtYzyUWq/6OnXMXXmvgwHE8
+nwrDNblsr8PX5WlYZx2sziXwlMeg8El1gGqsOQ9h0ERQRTj7JzuBA66l2tdUM5p4
+5Lf5JSRPRmH2AK5YLooTzJF11Hi6Pypv6pgNfxajwKg5W8HNrwHEYylJsF4dT6AF
+M6q4yc5nrjvKhoeu4WfdCRLKysgfewIBnexBYrriJpnCVq5An2ONP9+L7vy2ZdHw
+JiF99vCZtnoOzZ81CXvtlCU+TVcbyMo38oKzvYTrCY5dRuT6bo6profxkXgXvDzX
+2MKyDm5KlOxqDJpFtpshIa1GifFopHcyJLVtAgMBAAECggEAMb8AGDsFFdIgSZ32
+jUaq2q85zdUqoQcBCHlK1tQ3xhc85T0oCLNYcDWJCetXdJEuEh/BiCPM48Kl8JLO
+ZmFSNHLPGEWSvCk0Hcs5c/K8FfDgezc88GvyPbLHgdF2W0DEnd9k/1O9Tf86TCnA
+/5RAaAagjQzFuH8ZEl2rsU8R3WozX2zjpvGgnzq9dbGeTS2VPVTESlCgLMoQx1sX
++gBkKeghcV4VSTj8qFqJrIVbPkHrgnQ/5bphd2lc9lTPq9biZ7aL+z1bPp5z57NT
+4Ngpld/gSyN8XOO5keHqNX3R0qekmFsiOJVYRp6I/tE0HpX6q4iCeNyiqFkGD1wy
+AFYD4wKBgQD+toaj+OOFEUDsp3fsKxo5ogEwmCQvOGCRdqT75u0bCKLUNrggMXwK
+8FtGE406xuJdM/8qrMjjRv28pGCPDrS6uxIm8waWAQpN3zaj8sxQlgAINzHWUPS2
+3e2cwF4t6Xk6717UjLiphrDb/51M7B2xsHNx3L7xaxkhU+993OvozwKBgQD5/D/M
+du0f58ix7lKmeu6Yst42LH3zub7H0uDqYOCRHaKWl+j1lJlAS6SqRZRMIH/Ff87f
+ZSWnkWUGdSFNS8Srv0+qfR6a99D0yOyp2ISg6ef7nQZ0xFapyb4BmLCuZTpdNS6w
+Lp5vognSNdTAg0riQ7y9hyjOGWsLE3E0bDgVAwKBgQDMZM/aWOjKaTP+M8zJ2TSs
+NtJZmly+/7COSfTOp1pxLRbs0BQk0VDGvmWf8CSOm/Yd8JG8PvbdWqRWclmBsr1Y
+crF4S+BnEuKf5pTELxvBNv1DmncFkeUtsRzxgnSQxx+fKWKhkWLFtu3JPG+PwJF7
+eyrInekjdVuvINm32EX+hQKBgHS7iOMmaaYravlDa47X+tCNPdyYPBxykRbobySj
+Jlo9N24Q87Sxtjpi2Dq2kQBXcLK98tE4fzPXXhB845cfmXAFvuLC2GbO7+FObc0G
+ETC+6RgChEBEap+QWEyQi3h0RqO9sNaOfmdsiB+ECZv38yDjNqBeG/zZu7WJV6R+
+IFYXAoGAOHM2/N7bswfzXN4BkHCxhp41wCLXC6ifI3VjOHFsDRd/jnjyfNYqbiQ8
+CCRDdWBKezRE6qqEyQuzizRZPCRQgWLQOKYiImsKCfzyVSL9zkZ4q+pZU4aKgBbJ
+bNwiGS6+Ji++GNDMqSu8JDRQMKdA7jJfEY0IDFRrti2ZvmAKVeg=
+-----END RSA PRIVATE KEY-----
Index: examples/acme_rockets_intersection/Batman_ID.pem
===================================================================
--- examples/acme_rockets_intersection/Batman_ID.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
+++ examples/acme_rockets_intersection/Batman_ID.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
@@ -0,0 +1,19 @@
+-----BEGIN CERTIFICATE-----
+MIIDBzCCAe+gAwIBAgIIOxJa5YgASj4wDQYJKoZIhvcNAQEFBQAwETEPMA0GA1UE
+AxMGQmF0bWFuMB4XDTEwMDkxNzIwMzcxOVoXDTEzMDkwMTIwMzcxOVowETEPMA0G
+A1UEAxMGQmF0bWFuMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA2Ngr
+ZRYcJBhJaB1wt7z79A707NgUAJyx0yb2P4VyHTqerUveyixwjG6aG4fKn0W4QjtS
+WMy4+SOB3LXm2tTDre0SVYcqXTPydBnIkjrNMe8a52XTsuG6GU6n3/tGhQrx2cRs
+XORcNzTOhhBAhKFA0sdHCig4e2bdef3WlagqDDURGunDFSXR2j4aeTIHFKYVUJOh
+pvUxhOnZyegiQA1g9H/DfRrfLvoMvD6WeVmTdWj/yMXzl9+EpqEwdQeBKiO1o1qr
+3gC5UYFMzwDmkn/6b+1+AzOclUd2U8gstWnqT02Lwfs/ee+aNloeE1S0QO4LTcnE
+xDq1i8pLhQmeAs8FEwIDAQABo2MwYTAPBgNVHRMBAf8EBTADAQH/MA4GA1UdDwEB
+/wQEAwIBBjAdBgNVHQ4EFgQUmaSKn/zMyWdMUX/anfufCJey3mwwHwYDVR0jBBgw
+FoAUmaSKn/zMyWdMUX/anfufCJey3mwwDQYJKoZIhvcNAQEFBQADggEBAGw6n7jY
+sU0W+6o/WMyVp6+3EIC8tusVXm2rn9udlM+I6WAJx5hh2GZMTcR+Zp7QHBs9ncm7
+sMsMsd9sUWb11GUk7PXCDulmKLD7MF8UWRn5xfCr1hMFUbrWGWBKeTXQqBIQDfeL
+3FGyq8raDdKYeO/3JMQE6XEC8pcDdrsGQJBb87BGlx+i6K5q+qjM4tAMosXjdhYk
+E2BbyPahoGBdK1fQOKYsDAJAJ1i9L0NuQ6lb3qhCfWT0Xb08szDnPpvpNLX0NoZY
+MXriRRgHnw65GkZTUtySXeXeTcezY2NXaH9e/sHPtLAnzbEyDLViFiT/cT5FVg50
+IxN8W+CReATNfk0=
+-----END CERTIFICATE-----
Index: examples/acme_rockets_intersection/Batman_private.pem
===================================================================
--- examples/acme_rockets_intersection/Batman_private.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
+++ examples/acme_rockets_intersection/Batman_private.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
@@ -0,0 +1,27 @@
+-----BEGIN RSA PRIVATE KEY-----
+MIIEpAIAAoIBAQDY2CtlFhwkGEloHXC3vPv0DvTs2BQAnLHTJvY/hXIdOp6tS97K
+LHCMbpobh8qfRbhCO1JYzLj5I4Hcteba1MOt7RJVhypdM/J0GciSOs0x7xrnZdOy
+4boZTqff+0aFCvHZxGxc5Fw3NM6GEECEoUDSx0cKKDh7Zt15/daVqCoMNREa6cMV
+JdHaPhp5MgcUphVQk6Gm9TGE6dnJ6CJADWD0f8N9Gt8u+gy8PpZ5WZN1aP/IxfOX
+34SmoTB1B4EqI7WjWqveALlRgUzPAOaSf/pv7X4DM5yVR3ZTyCy1aepPTYvB+z95
+75o2Wh4TVLRA7gtNycTEOrWLykuFCZ4CzwUTAgMBAAECggEAQDj10UCVIROYWh+u
+DJ0KOiRb4fG1KuE9wX3enL2XKJT9/fFkkJhM1SrEtbaoCjgJ9IPBRc+MUS10/rtZ
+HiK5ub9nGLGpmGUUP9KLFtQXhdx9KV99LZOxHGGxUqMHJcwyCP8l4PU5YphfOlGB
+6kYf/s1KevWilNnIaqMFdNmTan2ZHfLs2GLMY2u2FJ0OTGCEDevLfUh7QITnpXp1
+FkAXuhqrHfINOwr62FIEM/y6vEfTPRO1AhV/CnBiooRj+bZFwLxuSsEtbaxbJuDX
+ECuLCZtjIbuT3f1ewZJCSv/YH+pKJdjeBvFa2Wl1J09uoT9/ggv7YCdaPDW3YSgW
+y5dVwQKBgQD9dT8M+LFMk5QOzUx0Y/+4JivY8mRfEtbkS6z0RxGi+AzCLBqTwqRP
+BNi0+9KEXmlOk6d+qpoFj/k48F9yvWQcyT3kb5/z1ssntYxDtpsMJbuxYQzpDJt4
+1Hvi6nE8I3Nx3B0D7bfsoKTsxeGI5OYvqxppX17t4qtiORueZfAN8QKBgQDbBOr1
+RQDKF//+ANiHuWWMD2wrqXX9CHrwgKgWaFYdLqsEKDtCuvcmhqqJSCA6NG3u0KHR
+n1f/wxJBtUIE5qN8Kme0r+HI2DLS1gh8i2gRLEauXOYvhFRaJruvW8kh0PlHgQLS
+HeLE/5yuCOKk7WznFvC0DJZtNzhzZq8j1Y5PQwKBgQC1hjhO+Po6ZuO+KijcnxXx
+dF0o9okOUnbXcJ+BIDkwZ8jzdBTgyKFW+pieHlDqfpebMELghBzlaPTMY9NoYN4H
+g9Ww+oUrZSWA3hSEFo87BvdDFcfiTSY4Rq4nmVLaCGXRIR0iyClW7sLP1PUvTwjR
+ERFMcIKTiyjFozL1ofpocQKBgQDB8QPh9p1xV3k+wh77aIdsVAfUTfYF/2ll6Hdv
+iCqhIr8bKkj3mTnbqqn+cJjhEaY7MBHq3q/88g8LkmcIkfc4rxAwJwLHZ/LxUcgo
+CQY5FrzsD6VhdEuBnQTbjmp3gGYNFEecKgyxpytlzMZthzTFGUJCHVdjFN/vCIGU
+OLoQowKBgQDbcDLIef/l0EH9DG+sV/SZbhRJ3EO/gQXQRbhOBixJoRYNkRUJT8XV
+yHeFAE5crsPlknfzXh5FofGGA8gBLxzCZNN4aiA1FC8t29+NG6DTMYBQcttm2Rdm
+YlfBGDOPPWAV0TyVaQpy7VauuVXWPHPMteSzjoK6RJkLOqFYrc+Vrg==
+-----END RSA PRIVATE KEY-----
Index: examples/acme_rockets_intersection/Coyote_ID.pem
===================================================================
--- examples/acme_rockets_intersection/Coyote_ID.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
+++ examples/acme_rockets_intersection/Coyote_ID.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
@@ -0,0 +1,19 @@
+-----BEGIN CERTIFICATE-----
+MIIDCDCCAfCgAwIBAgIJAJt9V0HP3H/5MA0GCSqGSIb3DQEBBQUAMBExDzANBgNV
+BAMTBkNveW90ZTAeFw0xMDA5MTcyMDM3MDJaFw0xMzA5MDEyMDM3MDJaMBExDzAN
+BgNVBAMTBkNveW90ZTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBALjN
+0hzJp5ltUe4TD+b7eLz6bbqgc+Ei4sGIfqLkJmwhKhaC1mOW0F7bai4vPNe6NN0+
+IeeCvrs5uEhZzkdTePshff4ynaSTUq4lhf8DurnpP/21FeeaTKqMmhwIktEOxXQk
+af6TfWeIy/rjfbIvwtadozGGeYcPyGgQxlh6SruYcaCJP9bhsVZQKP5kJfBQjRUC
+fOhYQXXTQ2HSKzmsRwS0eNJzBTqCu8XaWel1VmjRoQqYxhhy1RFv8IQNSOrMuY/B
+TbBeUfjxT60qOg9vhdmGtWf2T89jWwos8WuDOhGpg5SyhechNyIt4QO/n2MA41o3
+3VKtMTgHvk7wLbPF+0ECAwEAAaNjMGEwDwYDVR0TAQH/BAUwAwEB/zAOBgNVHQ8B
+Af8EBAMCAQYwHQYDVR0OBBYEFKizfTlgbN6zsCzBL0gVhNrKR892MB8GA1UdIwQY
+MBaAFKizfTlgbN6zsCzBL0gVhNrKR892MA0GCSqGSIb3DQEBBQUAA4IBAQCWnTnP
+HItCbZlpouCoA5frg1P86NzUw3U6imY/ePLF0Q8lHt5iGrq6tppz467kc0bWUH1R
+uCT4XCBSgn70YY9d2QdaDZezfeE20EdgyxLsBh3jPRVSFx1ERwjVgWQYpHaCQSyf
+KBdhPH3mUw3s1bAkJxbg3ch2CZCTSuhwegjnsJ54w3P3GFkJYxjiMC/jwJawsmut
+CmNbuZ+2yxFpEw1yCNkT0q9HW4aYCyzzKFCjB9TVzbbET1RznPAlHcnrysJhkF1Z
+hRjAjFHa/7i1rSiCrk8HfONgJPMLtHz3+cSamKznDXlOXsXQ0i3pvq3H9QL0t4mG
+3W5gXm1meQO57+h1
+-----END CERTIFICATE-----
Index: examples/acme_rockets_intersection/Coyote_private.pem
===================================================================
--- examples/acme_rockets_intersection/Coyote_private.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
+++ examples/acme_rockets_intersection/Coyote_private.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
@@ -0,0 +1,27 @@
+-----BEGIN RSA PRIVATE KEY-----
+MIIEoQIAAoIBAQC4zdIcyaeZbVHuEw/m+3i8+m26oHPhIuLBiH6i5CZsISoWgtZj
+ltBe22ouLzzXujTdPiHngr67ObhIWc5HU3j7IX3+Mp2kk1KuJYX/A7q56T/9tRXn
+mkyqjJocCJLRDsV0JGn+k31niMv6432yL8LWnaMxhnmHD8hoEMZYekq7mHGgiT/W
+4bFWUCj+ZCXwUI0VAnzoWEF100Nh0is5rEcEtHjScwU6grvF2lnpdVZo0aEKmMYY
+ctURb/CEDUjqzLmPwU2wXlH48U+tKjoPb4XZhrVn9k/PY1sKLPFrgzoRqYOUsoXn
+ITciLeEDv59jAONaN91SrTE4B75O8C2zxftBAgMBAAECggEADc09UG4VCMXb1RJy
+YRdN1JtFX6dFED7ZPYfyoTq1zeSKLqU12rk0NalgXDOl8RyUfyN5R7+BfB0a8LhY
+SgZnZiYBsV7ZXCWuipf90mZWZzUO1OVVzfa9nA0lI0vWnythvsNLcTpVpspWJZYg
+2JJtlDawre2znM0mc/MwxQHZG/ptnk87XivxC2qDcqHMa83TAjFz7ZXvkoeP8OtR
+4+LO3ARizw8cS3o/ezecFXnZbufssM6qn2Qgr0AInHeQ62nxF8djm2S913lLGGNf
+muLSORzD+dq5r4WxFIS/5HlrKXs/V6uTGCK7mQVIHAPuzjyIcTTY8pVNFynMxpmy
+tNdtAwKBgQDe/O7GC/lIl1BItC77ikVPNAN+Zx6o5m+VCbx8Cv4d+PdQZgqQbHtb
+z4FEpG4RfOKJ5W4f1YIOf90wHgKvxd8IICiZ60aKo/j47IxM284HOEiJnjju+Mpl
+rQHbC6VMXkmHwSrcXMb5WcShaDTQT1RLEMF7drX2FKeC3grQYTLrewKBgQDUKb5s
+2j4mTUMlS//QK2YTpI+vjOwFe/OYj4NL5jq9VfHjmETRqk2e6ViEpUvy2Ao0bE6V
+8JNOHq1NijM3yDpD5o/eb1KpAr3iz91zHIrrgNdjzIcIYULBurIxOH3/H33A783r
+F44dQ04Eg99kqAQC0R9yE7VYdMrN0V8PGbapcwKBgH46ekQcRRplpanybeIwzLlg
+PVYRs9Zy09lvcIZbhqya4g1eJj7JWi+H0Kp11mUJ6Aedm/BjYcMpeKGja2vrPC0S
+X0l6WS1kUy0+YtGjYAbQQqe8rIgCyDg0bqd7+S+49DDoFYY28t/2hAvGvJbrQVFZ
+A94LPkg2OvknDsIVM8j/AoGAIVxC/hi/BwTFFxtBKTl5voL0uPTes+oOnqGKUqfr
++pOGCnSJ9bHirKcibREUxSWlTSLupHMEppb6RyQA87d/OegKHT7B76Nnuj9XId+O
+FIPY2m9xmCa6+X1iwYyRe0k3W9wZM+srRHytytX1jX1BzDOXzzc8H6GVthFC8jvn
+1fMCgYBlGdZ2Gc+EWVvjcF1WaVU1ZqU0h/VMOxCU36KBEGrQGVoVPjKXf+g5eLlA
+sep957e9rA3LvZ5Kl2V0Xq0f0vgZ8yprPg8rhqHsdHQL4S1WtIeHdp65FWrSy6XR
+fvjK/6X/SomgKb8y407FJcSJOGb8tSXjegrjqFRzhikQEFJUjw==
+-----END RSA PRIVATE KEY-----
Index: examples/acme_rockets_intersection/README
===================================================================
--- examples/acme_rockets_intersection/README	(revision 6180394e7cc3259640222875ad742a564dd4671d)
+++ examples/acme_rockets_intersection/README	(revision 6180394e7cc3259640222875ad742a564dd4671d)
@@ -0,0 +1,46 @@
+This example demonstrates intersections.
+
+In order to buy rockets from Acme, you must be BOTH a preferred customer
+AND a WarnerBros character. In this example, the following query will be
+successful:
+
+    Acme.buy_rockets <-?- Coyote
+
+The following query will fail (because Batman does not have the
+attribute WarnerBros.character):
+
+    Acme.buy_rockets <-?- Batman
+
+Acme.buy_rockets <- Acme.preferred_customer & WarnerBros.character
+Acme.preferred_customer <- Coyote
+Acme.preferred_customer <- Batman
+WarnerBrothers.character <- Coyote
+
+creddy --generate --cn Acme
+
+creddy --generate --cn WarnerBros
+
+creddy --generate --cn Coyote
+
+creddy --generate --cn Batman
+
+creddy --attribute \
+       --issuer Acme_ID.pem --key Acme_private.pem --role buy_rockets \
+       --subject-cert Acme_ID.pem --subject-role preferred_customer \
+       --subject-cert WarnerBros_ID.pem --subject-role character \
+       --out Acme_buy_rockets__Acme_preferred_customer_and_WarnerBros_character_attr.der
+
+creddy --attribute \
+       --issuer Acme_ID.pem --key Acme_private.pem --role preferred_customer \
+       --subject-cert Coyote_ID.pem \
+       --out Acme_preferred_customer__Coyote_attr.der
+
+creddy --attribute \
+       --issuer Acme_ID.pem --key Acme_private.pem --role preferred_customer \
+       --subject-cert Batman_ID.pem \
+       --out Acme_preferred_customer__Batman_attr.der
+
+creddy --attribute \
+       --issuer WarnerBros_ID.pem --key WarnerBros_private.pem --role character \
+       --subject-cert Coyote_ID.pem \
+       --out WarnerBros_character__Coyote_attr.der
Index: examples/acme_rockets_intersection/WarnerBros_ID.pem
===================================================================
--- examples/acme_rockets_intersection/WarnerBros_ID.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
+++ examples/acme_rockets_intersection/WarnerBros_ID.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
@@ -0,0 +1,19 @@
+-----BEGIN CERTIFICATE-----
+MIIDDzCCAfegAwIBAgIIam44l3UdZ5UwDQYJKoZIhvcNAQEFBQAwFTETMBEGA1UE
+AxMKV2FybmVyQnJvczAeFw0xMDA5MTcyMDM2NDVaFw0xMzA5MDEyMDM2NDVaMBUx
+EzARBgNVBAMTCldhcm5lckJyb3MwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEK
+AoIBAQCpgqFydgXSIOEg/H1szr5ZVh0rKpXtrPLGzm2NvfJlTxJrX1MY1oLZ96Q+
+E702GYvXjP3SNZe91dWwYbGZ8Cm9OilCV5GyXPTNkVh1cFogp+0efJ0ws5ZYW29T
+RwCqD+W44xTmX4+/VqBQqsm1WPfgMioUSEzV/AA/Cb7P0IgJRLKddWI9rufF1eXs
+4f4M5/z5MoituLng89Oqe/6Ea5O8UVwCQ62VCL5HijIxOG1qtvMriSmfUGXUDzQc
+BTCw5t+oOjxkmuQjiy0lQv68rspW8nb4+hgn+/SDIAgXMkvldC+a7pAaRWSva9rF
+83SirjhKGpawIrEax3glTupSMW0hAgMBAAGjYzBhMA8GA1UdEwEB/wQFMAMBAf8w
+DgYDVR0PAQH/BAQDAgEGMB0GA1UdDgQWBBT9slPQ4bzw1gqHhNWzDcjgBkYH0DAf
+BgNVHSMEGDAWgBT9slPQ4bzw1gqHhNWzDcjgBkYH0DANBgkqhkiG9w0BAQUFAAOC
+AQEATTtGBPyGnXx/4LdJYi3h4THMDvBLS1ZDYpiKHcU3GJvgN0WJVAZQb7sHSlGq
+/ObZPS7bUilwEIwdKlz9oByR0aQmW1UiERTq2gEsfnj+uJCShHZx9qNzp8yWp5Tj
+I2ceXyntZ2E3k2ckWkt+sTKqOhLwnz/9D8NhzCi8+rMOld+MxUvCLe1yZHTD5KDN
+yEviVhSXYUW015Daa24lRLXZMCo+v669p8iuIUwtS1yOWkeWUXgLEgk91Nu00jNH
+5E9rSVa062Vp0FzPwZpDuAqOYPdQuMe0GX9LyhRzThgOQI2f/iBHsRJ+ePLzwLW6
+clx0ijr3jWLXMIsifhDKtSVkSQ==
+-----END CERTIFICATE-----
Index: examples/acme_rockets_intersection/WarnerBros_private.pem
===================================================================
--- examples/acme_rockets_intersection/WarnerBros_private.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
+++ examples/acme_rockets_intersection/WarnerBros_private.pem	(revision 6180394e7cc3259640222875ad742a564dd4671d)
@@ -0,0 +1,27 @@
+-----BEGIN RSA PRIVATE KEY-----
+MIIEoAIAAoIBAQCpgqFydgXSIOEg/H1szr5ZVh0rKpXtrPLGzm2NvfJlTxJrX1MY
+1oLZ96Q+E702GYvXjP3SNZe91dWwYbGZ8Cm9OilCV5GyXPTNkVh1cFogp+0efJ0w
+s5ZYW29TRwCqD+W44xTmX4+/VqBQqsm1WPfgMioUSEzV/AA/Cb7P0IgJRLKddWI9
+rufF1eXs4f4M5/z5MoituLng89Oqe/6Ea5O8UVwCQ62VCL5HijIxOG1qtvMriSmf
+UGXUDzQcBTCw5t+oOjxkmuQjiy0lQv68rspW8nb4+hgn+/SDIAgXMkvldC+a7pAa
+RWSva9rF83SirjhKGpawIrEax3glTupSMW0hAgMBAAECggEAICRoDrc4dVbMuZ+G
+/Pna+D+u+j9x/IZ95prABU+ORg2PVZLWw+/xEfm2SBsgFsETVkUi4BhPdKy2f2KW
+9bSnhX0g07adJvAfb1dvKZ2rSWPuP4irmc+D46861dSx2I15JuzQSrq2HDcF4SXx
+Z5S+M+HvPrdS8oR9W3aymt9U3ES+TeOIiSdW25DQbW00BZ1HJ+0h/gfxsufT/LQ1
+Lio94yRHiwqgpyJrUgl6zxVlk2HOZQSDfOK5Of9+QZF6FxH/lxuldRBXYIh7MLr9
+aznQvAovYGpYzYP/FFCsPEbnEVYTR7K2ZPM2Hh2ZbEp7Y7sj0zXS+eOpI/2wvpr0
+wlcKXQKBgQDgVYCVUrIA4Z/ewnS7Q/UJ251rsKOBm+TqOLKpk01OQ0noO1tj1dpY
+qpp8xvKJG8Y7UUiAVZQVe/4XCpl9WOca90/fwCILragjdg45FnARCJtDp56eA7ci
+tEzzO6HHh1Vk5Ebn82oL01NbYzP6OTXjj8FWWFTkw0PhEryZhUT2OwKBgQDBcAb2
+ECyM2XbmA88P2BrLnt0yBKT+seuF1L8N/JrCCPB9Sadsi63SMBaler+/6YRiwZ3T
+eB+FyXTqsvQFExGS8GvdRtkKNntnRGkSuzYX2AOdzxt3rCcPepMLXKnuRNc7+oh3
+UL7QdVjiED7lzAgWy9MuQwaScQqRm3zCnG9IUwJ/MDIubeZWV9ohfrpIWfM/sd58
+86X/etkDVU7ZE5WSBj5uonYeLFTFlEcS6bvUX6CX9iaAbRH1vqfk7w5X65YuEJ0R
+jAC7T8b/WJ8Ebz9i1EYFFYPtkAU8UzhpT9h/6V4p+oMQuMSTA/di8T9e62NfMISy
+BNr1YjCRZMmhu1nmdwKBgH3yYiXujAM9SIQlMLmhPHkdu+noSkGnOLGPvsHtmhoC
+VgtNXJx5Kbj0JJqkHJtpARCH/ioFSYkDjYOO9wEi1Et3DNQrX/+dT6YCTeOrT2Ig
+/OHQSpMV3OzgI0O/lskTu4xK6HW/di4mabPvXfSjbxTgq2SwsWPCBF6f/ZB86JwP
+AoGBAJbjAgvBODyspNBJIEm3FswqL7KHMKAAXDrPL/waVskpFVR/LpOnCyK8WsEN
+PGo133wirEZ5EqdhGgho1OdxgQQ//KLDXc/7Rvy9AuLotqvbdjXOEog5i0ntNLKv
+Aw6BZLwd8lIn0Ax4N7r+AmUP9ADU6T1CWeGkA19NNMoH00gA
+-----END RSA PRIVATE KEY-----